using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ConfectioneryContracts.BindingModels;
using ConfectioneryContracts.ViewModels;
using System.Xml.Linq;
using ConfectioneryDataModels.Models;

namespace ConfectioneryFileImplement.Models
{
    public class MessageInfo : IMessageInfoModel
    {
        public string MessageId { get; set; } = string.Empty;
        public int? ClientId { get; set; }
        public string SenderName { get; set; } = string.Empty;
        public DateTime DateDelivery { get; set; }
        public string Subject { get; set; } = string.Empty;
        public string Body { get; set; } = string.Empty;
        public static MessageInfo? Create(MessageInfoBindingModel model)
        {
            if (model == null)
            {
                return null;
            }

            return new()
            {
                MessageId = model.MessageId,
                ClientId = model.ClientId,
                SenderName = model.SenderName,
                DateDelivery = model.DateDelivery,
                Subject = model.Subject,
                Body = model.Body,
            };
        }
        public static MessageInfo? Create(XElement element)
        {
            if (element == null)
            {
                return null;
            }

            return new()
            {
                MessageId = element.Attribute("MessageId")!.Value,
                ClientId = Convert.ToInt32(element.Attribute("ClientId")!.Value),
                SenderName = element.Attribute("SenderName")!.Value,
                DateDelivery = Convert.ToDateTime(element.Attribute("DateDelivery")!.Value),
                Subject = element.Attribute("Subject")!.Value,
                Body = element.Attribute("Body")!.Value
            };
        }
        public MessageInfoViewModel GetViewModel => new()
        {
            MessageId = MessageId,
            ClientId = ClientId,
            SenderName = SenderName,
            DateDelivery = DateDelivery,
            Subject = Subject,
            Body = Body
        };
        public XElement GetXElement => new("MessageInfo",
            new XAttribute("MessageId", MessageId),
            new XAttribute("ClientId", ClientId),
            new XAttribute("SenderName", SenderName),
            new XAttribute("DateDelivery", DateDelivery),
            new XAttribute("Subject", Subject),
            new XAttribute("Body", Body));
    }
}
